package it.demo.prove;

//Classi definite da noi
import it.demo.dominio.Persona;
import it.demo.util.HibernateUtil;

//Classi di Hibernate
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.HibernateException;
import org.hibernate.Query;

//Classi generiche
import java.util.List;

/**Classe che fa vedere come usare Hibernate 
 * @author Leonardo Puleggi
 *
 */
public class ProvaEsempio_05 {
	
	/**Restituisce una lista di tutte le Persone salvate nel database
	 * 
	 * @return lista delle Persone del database
	 */
	@SuppressWarnings("unchecked")
	public static List<Persona> listaTuttePersone() {
		List<Persona> result=null;
		
		Session session = HibernateUtil.getSessionFactory().openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			Query q = session.createQuery("from Persona");
			//Query q = session.createQuery("from Persona as p left outer join fetch p.job");
			result=q.list();
			tx.commit();
		}
		catch (HibernateException he) {
			if (tx!=null) 
				tx.rollback();
			throw he;
		}
		finally {
			session.close();
		}
		
		return result;
	}

	/**Esegue tutti i metodi di prova
	 * 
	 */
	public static void main(String[] args) {
	
		System.out.println("Stampo tutte le persone con i rispettivi job");
		List<Persona> l=listaTuttePersone();
		for (Persona p:l)
			System.out.println(p.toString());

	}
}